#include "fcsb.hpp"



static void InitDialogItems(struct InitDialogItem *Init,struct FarDialogItem *Item,
                    int ItemsNumber)
{
  for (int I=0;I<ItemsNumber;I++)
  {
    Item[I].Type=Init[I].Type;
    Item[I].X1=Init[I].X1;
    Item[I].Y1=Init[I].Y1;
    Item[I].X2=Init[I].X2;
    Item[I].Y2=Init[I].Y2;
    Item[I].Focus=Init[I].Focus;
    Item[I].Selected=Init[I].Selected;
    Item[I].Flags=Init[I].Flags;
    Item[I].DefaultButton=Init[I].DefaultButton;
    if ((unsigned int)Init[I].Data<2000)
      strcpy(Item[I].Data,GetMsg((unsigned int)Init[I].Data));
    else
      strcpy(Item[I].Data,Init[I].Data);
  }
}





int Config( void )
{
  struct InitDialogItem InitItems[]={
    // type, x1, y1, x2, y2, focus, selected, flags, default, data
    { DI_DOUBLEBOX,3,1,53,17,0,0,0,0,(char*)MesConfig },             // 0
    { DI_TEXT, 6, 2, 0, 0, 0,0,0,0, (char*)MesC7 },                  // 1
    { DI_TEXT, 6, 8, 0, 0, 0,0,0,0, (char*)MesC8 },                  // 2
    { DI_TEXT, 3, 7, 0, 0, 0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0, "" },   // 3
    { DI_TEXT, 3, 12, 0, 0, 0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0, "" },  // 4
    { DI_CHECKBOX, 8, 3, 0, 0, 1,0,0,0, (char*)MesC1 },              // 5
    { DI_CHECKBOX, 8, 4, 0, 0, 0,0,0,0, (char*)MesC2 },              // 6
    { DI_CHECKBOX, 8, 5, 0, 0, 0,0,0,0, (char*)MesC3 },              // 7
    { DI_CHECKBOX, 8, 6, 0, 0, 0,0,0,0, (char*)MesC4 },              // 8
    { DI_CHECKBOX, 8, 9, 0, 0, 0,0,0,0, (char*)MesC1 },              // 9
    { DI_CHECKBOX, 8, 10, 0, 0, 0,0,0,0, (char*)MesC2 },             // 10
    { DI_CHECKBOX, 8, 11, 0, 0, 0,0,0,0, (char*)MesC3 },             // 11
    { DI_TEXT, 6, 13, 0, 0, 0,0,0,0, (char*)MesC9 },                 // 12
    { DI_EDIT, 17, 13, 50, 13, 0,0,0,0, "" },                        // 13
    { DI_CHECKBOX, 6,14,0,0, 0,0,0,0, (char*)MesC10 },               // 14
    { DI_CHECKBOX, 6,15,0,0, 0,0,0,0, (char*)MesC11 },
    { DI_BUTTON,3,18,0,0,0,0,0,1,(char *)MesC5 },                    // 16
    { DI_BUTTON,11,18,0,0,0,0,0,0,(char *)MesC6 }                    // 17
  };

  struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
  InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));

  char mask[512];
  int CountStatic = GetRegKey(HKEY_CURRENT_USER,"",CTSTATIC, 0 );
  int CountInline = GetRegKey(HKEY_CURRENT_USER,"",CTINLINE, 1 );
  int CountCPP    = GetRegKey(HKEY_CURRENT_USER,"",CTCPP   , 1 );
  int ExitMenu    = GetRegKey(HKEY_CURRENT_USER,"",QUITMENU, 0 );

  int CountStaticE = GetRegKey(HKEY_CURRENT_USER,"",CTSTATICE, 1 );
  int CountInlineE = GetRegKey(HKEY_CURRENT_USER,"",CTINLINEE, 1 );
  int CountCPPE    = GetRegKey(HKEY_CURRENT_USER,"",CTCPPE   , 1 );
  int Recurse      = GetRegKey(HKEY_CURRENT_USER,"",RECURSE  , 1 );
  int MoveToFun    = GetRegKey(HKEY_CURRENT_USER,"",MOVETOFUN, 1 );
  GetRegKey( HKEY_CURRENT_USER, "", FILEMASK , mask, DEFAULTFILEMASK, 512 );

  if ( CountStatic ) DialogItems[5].Selected = 1;
  if ( CountInline ) DialogItems[6].Selected = 1;
  if ( CountCPP )    DialogItems[7].Selected = 1;
  if ( ExitMenu )    DialogItems[8].Selected = 1;

  if ( CountStaticE ) DialogItems[9].Selected = 1;
  if ( CountInlineE ) DialogItems[10].Selected = 1;
  if ( CountCPPE )    DialogItems[11].Selected = 1;
  if ( Recurse )      DialogItems[14].Selected = 1;
  if ( MoveToFun )    DialogItems[15].Selected = 1;
  strcpy( DialogItems[13].Data , mask );

  int ExitCode=_Info.Dialog(_Info.ModuleNumber,-1,-1,57,20,CONTENTS,DialogItems,sizeof(DialogItems)/sizeof(DialogItems[0]));

  if (ExitCode!=16) {
    return(FALSE);
  }

  strcpy( mask , DialogItems[13].Data );
  if ( DialogItems[5].Selected ) CountStatic = 1; else CountStatic = 0;
  if ( DialogItems[6].Selected ) CountInline = 1; else CountInline = 0;
  if ( DialogItems[7].Selected ) CountCPP    = 1; else CountCPP    = 0;
  if ( DialogItems[8].Selected ) ExitMenu    = 1; else ExitMenu    = 0;

  if ( DialogItems[9].Selected )  CountStaticE = 1; else CountStaticE = 0;
  if ( DialogItems[10].Selected ) CountInlineE = 1; else CountInlineE = 0;
  if ( DialogItems[11].Selected ) CountCPPE    = 1; else CountCPPE    = 0;

  if ( DialogItems[14].Selected ) Recurse      = 1; else Recurse      = 0;
  if ( DialogItems[15].Selected ) MoveToFun    = 1; else MoveToFun    = 0;

  SetRegKey(HKEY_CURRENT_USER,"",CTSTATIC, CountStatic );
  SetRegKey(HKEY_CURRENT_USER,"",CTINLINE, CountInline );
  SetRegKey(HKEY_CURRENT_USER,"",CTCPP, CountCPP );
  SetRegKey(HKEY_CURRENT_USER,"",QUITMENU, ExitMenu );
  SetRegKey(HKEY_CURRENT_USER,"",CTSTATICE, CountStaticE );
  SetRegKey(HKEY_CURRENT_USER,"",CTINLINEE, CountInlineE );
  SetRegKey(HKEY_CURRENT_USER,"",CTCPPE, CountCPPE );
  SetRegKey(HKEY_CURRENT_USER,"",RECURSE, Recurse );
  SetRegKey(HKEY_CURRENT_USER,"",MOVETOFUN, MoveToFun );
  SetRegKey(HKEY_CURRENT_USER,"",FILEMASK, mask );

  return(TRUE);
}
