#include "fcsb.hpp"

// #define TEST
#define MaxDeepRepeatScan 100 //ᨬ쭠 㡨 ஢ન  ᮢ  ୮ ᪠஢

struct   PluginStartupInfo _Info;
char     PluginRootKey[80];

char     CTSTATIC[] = "CtStatic";
char     CTINLINE[] = "CtInline";
char     CTCPP[]    = "CtCPP";
char     QUITMENU[] = "QuitMenu";
char     CONTENTS[] = "Contents";
char     OPERATOR[] = "operator";
char     CTSTATICE[] = "CtStaticE";
char     CTINLINEE[] = "CtInlineE";
char     CTCPPE[]    = "CtCPPE";
char     RECURSE[]   = "Recurse";
char     MOVETOFUN[] = "MoveF";
static char FARPRJ[]  = "fcsbprj$.Far";
static char FARPRJU[] = "fcsbpru$.Far";

static char RSLPRJ[]  = "*.MAC";

char     Version[]   = "FCSB v3.0 (c)1999 by Serge Alexandrov (c)2001 by Azartsov Valery";

char DEFAULTFILEMASK[] = "*.c;*.cpp;*.h;*.hpp";
char FILEMASK[] = "FileMask";


bool CheckForEsc( void )
{
  int ExitCode=false;
  while (1)
  {
    INPUT_RECORD rec;
    static HANDLE hConInp=GetStdHandle(STD_INPUT_HANDLE);
    DWORD ReadCount;
    PeekConsoleInput(hConInp,&rec,1,&ReadCount);
    if (ReadCount==0)
      break;
    ReadConsoleInput(hConInp,&rec,1,&ReadCount);
    if (rec.EventType==KEY_EVENT)
      if (rec.Event.KeyEvent.wVirtualKeyCode==VK_ESCAPE)
        ExitCode=true;
  }
  return(ExitCode);
}

static int BelongToUs( char *name, char *mask )
{
 char copymask[520];

 if ( !strlen(mask ) ) return 0;
 if ( _Info.CmpName( name, FARPRJ, TRUE ) ) return 0;

 if ( _Info.CmpName( RSLPRJ, name, TRUE ) ) return 2; //ਧ RSL-䠩

 strcpy( copymask, mask );

 if ( copymask[ strlen(copymask) - 1 ] != ';' )
    strcat( copymask, ";" );

 char *begin = copymask;
 char *ptr = strchr( copymask, ';' ) ;
 while ( ptr ) {
    *ptr = 0;
    if ( _Info.CmpName( begin, name, TRUE ) ) return 1;
    begin = ptr+1;
    ptr = strchr( ptr+1, ';' ) ;
 }
 return 0;
}


char *GetMsg(int MsgId)
{
  return(_Info.GetMsg(_Info.ModuleNumber,MsgId));
}


static void SayError( int n )
{
 char *Err[3];

 Err[0] = GetMsg( MesErrHead );
 Err[1] = GetMsg( n );
 Err[2] = GetMsg( MesOk );

 _Info.Message( _Info.ModuleNumber, FMSG_WARNING, NULL, Err, 3, 1 );
}

static int compare(const void *arg1, const void *arg2 )
{  
   return stricmp( ((FUNC *)(arg1))->Func, ((FUNC *)(arg2))->Func ); 
}

static void Sort( FCSBPARM *parm )
{
 if ( !parm->itemnum ) return ;
 qsort( parm->fptr, parm->itemnum, sizeof(FUNC), compare );
}


static int AddFunc( FUNC *f , FCSBPARM *parm, bool InUnsortFile = false )
{
 FUNC **fptr   = InUnsortFile ? &parm->fptru    : &parm->fptr;
 long *itemnum = InUnsortFile ? &parm->UnsortItemNum : &parm->itemnum;
 long *ptrsize = InUnsortFile ? &parm->UnsortPtrSize : &parm->ptrsize; 
 (*itemnum)++;
 if ( (*ptrsize) < (*itemnum) ) {
    (*ptrsize) += DPTRSIZE;
    (*fptr) = (FUNC*)realloc( (*fptr), (*ptrsize)*sizeof(FUNC) );

    if ( !(*fptr) ) return -1;
 }
 (*fptr)[(*itemnum)-1] = *f;
 return 0;
}


#pragma argsused
static int ffungetc( int c, FILE *fp, FCSBPARM *parm )
{
 if ( parm->Editor ) {
    parm->CharNumber--;
    if ( parm->CharNumber < 0) {
       struct EditorGetString ss;
       ss.StringNumber = ( --parm->StringNumber );
       if ( !_Info.EditorControl( ECTL_GETSTRING, &ss ) ) return -1;
       parm->CharNumber = ss.StringLength;
       parm->MaxCurLen  = ss.StringLength;
       parm->CurLinePtr = ss.StringText;
    }
    return 0;
 } else {
    return fseek( fp , -1 , SEEK_CUR );
 }
}


#pragma argsused
static int ffgetc( FILE *fp, FCSBPARM *parm )
{
 if ( parm->Editor ) {
    struct EditorGetString ss;
    int c;

    if ( !parm->CharNumber ) {
       ss.StringNumber = parm->StringNumber;
       if ( !_Info.EditorControl( ECTL_GETSTRING, &ss ) ) return EOF;
       parm->MaxCurLen  = ss.StringLength;
       parm->CurLinePtr = ss.StringText;
    }

    if ( parm->MaxCurLen <= parm->CharNumber ) c = '\n';
    else c = parm->CurLinePtr[ parm->CharNumber ];

    if ( parm->MaxCurLen > parm->CharNumber ) parm->CharNumber++;
    else { parm->CharNumber = 0; parm->StringNumber++; }
    return c;

 } else {
    int c = fgetc( fp );
    if ( c == 0 ) return '\n';
    if ( c == 0x0D ) {
       int cc = fgetc( fp );
       if ( cc != 0x0A ) {
          ffungetc( cc, fp, parm );
          return '\n';
       }
       return '\n';
    }
    return c;
 }
}



static int filter_eol( FILE *fp_source , FCSBPARM *parm )
{
 int c;

 while ( 1 ) {
    c = ffgetc( fp_source , parm );
    if ( c == '\\' ) {

       int cc = ffgetc( fp_source , parm );
       if ( cc != '\n' ) {
          ffungetc( cc, fp_source , parm );
          return '\\';
       }
       parm->line_num ++ ;

    } else return c;
 }

}



static int filter_cmt( FILE *fp_source , FCSBPARM *parm )
{
        /* values for state */
        int c, state=STABLE, cmt_level = 0;

        while( TRUE )
                {
                c = filter_eol(fp_source,parm); // was: fgetc

                if( c == '\n') {
                   parm->line_num++;
                   if ( state == LINE_CMT ) state = STABLE;
                }
                else if( c == EOF )
                        return EOF;

                switch(state)
                        {
                        case STABLE:
                                if( c == '*' )
                                        state = OUT_CMT_STAR;
                                else if( c == '/' )
                                        state = IN_CMT_FS;
                                break;

                        case IN_CMT_FS:
                                if( c == '*' )
                                        {
                                        state = STABLE;
#ifdef NESTED_COMMENTS
                                        cmt_level++;            /* descend one comment level */
#else
                                        cmt_level = 1;          /* descend to comment level */
#endif
                                        continue;
                                        }
                                else if( c == '/' && !cmt_level ){
                                        state = LINE_CMT;
                                        continue;
                                        }
                                else if( !cmt_level )   /* if '/' not followed by '*'
                                                                                        and outside any comment   */
                                        {ffungetc( c, fp_source , parm);        /* push back this char
                                                                                                        and return the '/' */
                                        return '/';
                                        }
                                else if( c != '/' )             /* stay in state IN_CMT_FS     */
                                        state = STABLE;         /* if next char is '/' as well */
                                break;
                        
                        case OUT_CMT_STAR:
                                if( c == '/' )
                                        {
                                        cmt_level--;            /* ascend one comment level */
                                        state = STABLE;
                                        continue;
                                        }
                                else if( ! cmt_level )  /* if '*' not followed by '/' */
                                        {                                       /* and outside any comment    */
                                        ffungetc( c, fp_source , parm );  /* push back this char   */
                                        return '*';                                     /* and return the '*' */
                                        }
                                else if( c != '*' )                     /* stay in state IN_CMT_FS  */
                                        state = STABLE;                 /* if next char is '*' as well */
                                break;
                        }

                if( state == STABLE && !cmt_level )     /* if outside any comment */
                        return c;                                               /* return character       */
                }
}




/*
        Using the stream returned by filter_cmt() as input, return a
        character stream in which any quoted character or quoted string has
        been collapsed to the single special value QUOTES to avoid
        considering special characters like '{', '}', '(', or ')' which may
        occur within quotes.  
*/
static int filter_quotes( FILE *fp_source , FCSBPARM *parm )
{
        int c1, c2;

        if( (c1 = filter_cmt(fp_source,parm)) != '\'' && c1 != '"' )
                return c1;              /* pass char through if not a single or double quote */
        while( TRUE )
                {
                switch( c2 = filter_cmt(fp_source,parm) )
                        {
                        case '\\':                                      /* beginning of escape sequence */
                                filter_cmt(fp_source,parm);  /* so eat next char */
                                break;
                        case EOF:
                                return EOF;
                        default:
                                if( c2 == c1 )                  /* found end of quoted char or string */
                                        return QUOTES;
                        }
                }
}



/*
        Utility routine used by filter_ppdir() -
        read the character stream using filter_quotes, storing characters
        int he parameter "line", until EOF or '\n' is encountered.  Return
        EOF or '\n' accordingly.
*/
static int get_ppdir_line( FILE *fp_source, char *line , FCSBPARM *parm )
{
        int i, c;

        for( i=0; i<MAXLINE && (c = filter_quotes(fp_source,parm)) != '\n'
                                        && c != EOF; i++)
                line[i] = (char)c;
        line[i] = 0;                            /* terminate string */
        if( c == EOF )
                return EOF;
        return '\n';
}



/*
        Using the stream returned by filter_quotes() as input, return a
        character stream in which all preprocessor directives have been
        eaten.
*/
static int filter_ppdir( FILE *fp_source , FCSBPARM *parm )
{
        int c; //, i;
        char line[MAXLINE + 1];

        while(TRUE)
        {
           if( (c = filter_quotes(fp_source,parm)) != '#' )
                   return c;       /* no, return character */

           if( (c = get_ppdir_line( fp_source, line , parm)) == EOF )
                   return EOF;

           //#define -⠪ 童塞 
           if( strncmp( line, "define", 6) )              /* if not #define directive */
                  continue;
           else{
              strcpy( parm->define, line ); 
              return DEFINE; 
           }
         }
}



/*
        Using the stream returned by filter_ppdir() as input, return a
        character stream in which all characters between '{' and the
        matching '}' have been replaced by the single special value BRACES
        (any nested braces within this top level pair will also have been
        eaten).  This will filter out anything internal to a function.
*/
static int filter_curly_braces( FILE *fp_source , FCSBPARM *parm )
{
        int brace_cnt, c;

        if( (c = filter_ppdir(fp_source,parm)) != '{' )
                return c;

        brace_cnt = 1;
        while( brace_cnt )                      /* wait for brace count to return to zero */
                {switch( filter_ppdir(fp_source,parm) )
                        {
                        case '}':
                                brace_cnt--;    /* subtract right braces */
                                break;
                        case '{':
                                brace_cnt++;    /* add left braces */
                                break;
                        case EOF:
                                return EOF;
                        }
                }
        return BRACES;                          /* brace count is now zero */
}

/*
        Using the stream returned by filter_curly_braces() as input, return
        a character stream in which all characters between '(' and the
        matching ')' have been replaced by the single special value PARENS
        (any nested parentheses within this top level pair will also have
        been eaten).  This will filter out anything within the parentheses
        delimiting the arguments in a function definition.
*/
static int filter_parens( FILE *fp_source , FCSBPARM *parm )
{
        int paren_cnt, c;

        if( (c = filter_curly_braces(fp_source,parm)) != '(' )
                return c;
        paren_cnt = 1;
        while( paren_cnt )
                {switch( filter_curly_braces(fp_source,parm) )
                        {
                        case ')':
                                paren_cnt--;
                                break;
                        case '(':
                                paren_cnt++;
                                break;
                        case EOF:
                                return EOF;
                        }
                }
        return PARENS;
}




static int filter_sqb( FILE *fp_source , FCSBPARM *parm )
{
        int paren_cnt, c;

        if( (c = filter_parens(fp_source,parm)) != '[' )
                return c;
        paren_cnt = 1;
        while( paren_cnt )
                {switch( filter_parens(fp_source,parm) )
                        {
                        case ']':
                                paren_cnt--;
                                break;
                        case '[':
                                paren_cnt++;
                                break;
                        case EOF:
                                return EOF;
                        }
                }
        return SQB;
}







/*
        Using the stream returned by filter_parens() as input, return a
        character stream in which any data initialization expressions
        between an equals sign and a semicolon have been replaced by a
        single semicolon.  This will filter out anything involving
        parentheses in a data initialization expression, which might
        otherwise be mistaken for a function definition.
*/
static int filter_data( FILE * fp_source , FCSBPARM *parm )
{
        int c;

        if( (c = filter_sqb(fp_source,parm)) != '=' )
                return c;
        while( (c = filter_sqb(fp_source,parm)) != ';' && c != EOF )
                ;
        return c;
}



/*
        assuming that the input line ends with a function name,
        extract and return this name (as a pointer into the input line).
*/
#pragma argsused
static char * get_fn_name(char *line, FCSBPARM *parm )
{
        char *name_ptr, *cppptr;
        int len, cppflag;
        char i;

        if( (len = strlen(line)) == 0 )
                return line;

        name_ptr = line + len - 1;

        while( isspace(*name_ptr) && name_ptr >= line)             /* skip trailing white space */
                name_ptr--;
        *(name_ptr + 1) = 0;                    /* terminate fn name */


        if ( ( cppptr = strstr( line , "::" ) ) != NULL ) {
           if ( !parm->CountCPP ) return( line + strlen(line) );
           name_ptr = cppptr-1;
           if ( name_ptr > line )  {
              // skipping lines like ::Func
              while ( *name_ptr == ' ' && name_ptr > line) name_ptr--;
              if ( name_ptr == line ) name_ptr = cppptr - 1;
           } else name_ptr = line;
        }

        cppflag = 0;                                            /* function names consist entirely of           */
                                                                /* alphanumeric chars and underscores           */
        while( (isalnum(*name_ptr) || *name_ptr == '_' || *name_ptr == '~' || *name_ptr == '<' || *name_ptr == '>' || cppflag>0 ) && name_ptr >= line ) {
                if ( *name_ptr == '>' ) cppflag ++;
                if ( *name_ptr == '<' ) cppflag --;
                name_ptr--;
        }

        if ( cppflag != 0 ) 
                return( line + strlen(line) );

        if( isdigit(*++name_ptr) )
                return( name_ptr + strlen(name_ptr) );
        /* Test if this is a static function */

        i = *name_ptr;
        *name_ptr = '\0';

        if ( ( strstr( line, "static" ) == NULL || parm->CountStatic ) &&
             ( strstr( line, "inline" ) == NULL || parm->CountInline ) &&
             ! strstr( line, "typedef" ) 
           ) *name_ptr = i;

        if ( !strncmp( name_ptr, OPERATOR, 8 ) ) 
                return( line + strlen(line) );

        return name_ptr;                        /* else return the function name                        */
}

//
char *Get_Struct_Name( FILE * fp_source, char *line, char *name_ptr, FCSBPARM *parm )
{
   //饬  typedef struct 
   char *tmp_ptr;
   if( (tmp_ptr = strstr( line, "typedef" )) != NULL )
   {
      //஡ᨬ ஡ ᫥ typedef
      tmp_ptr += 7;
      while( *tmp_ptr == ' ' ) tmp_ptr++;
      
      //뤥    ᫥
      if( *tmp_ptr && (strncmp( tmp_ptr, "struct", 6 ) == 0 || strncmp( tmp_ptr, "enum", 4 ) == 0) )
      {
         int cc;      
         //ய᪠ 騥 ஡, ⠡樨  ७ ப
         while( ((cc = ffgetc( fp_source, parm )) == ' ' || cc == '\n' || cc == '\t') && cc != EOF ) ;

         tmp_ptr = name_ptr;
         //⠥ 童  
         while( cc != EOF )
         {
            if( cc != ' ' && cc != ';' )
               *tmp_ptr++ = (char)cc;
            else{
               *tmp_ptr = '\0';                   
               return name_ptr;
            }
            cc = ffgetc( fp_source, parm );
         }  
      }
   }
   return NULL; 
}

char *Get_Define_Name( FCSBPARM *parm, char *name_ptr )
{
   char *tmp_ptr = parm->define, *beg_ptr;

   //஡ᨬ ஡ ᫥ "define "
   tmp_ptr += 7;
   while( *tmp_ptr == ' ' || *tmp_ptr == '\t' || *tmp_ptr == '\n' ) tmp_ptr++;
      
   beg_ptr = tmp_ptr;
   //뤥塞 , ६   ࢮ ࠧ⥫
   while( *(tmp_ptr++) != 0 ){ 
      if( *tmp_ptr == '\t' || *tmp_ptr == '\r' || *tmp_ptr == '\n' || *tmp_ptr == ' ' || *tmp_ptr == '(' || *tmp_ptr == '{' )
         break;
   }
   *tmp_ptr = '\0';

   if( *beg_ptr != 0 ){
      strcpy( name_ptr, beg_ptr );
      return name_ptr; 
   }
   else
      return NULL; 
}

/*
 㦥 騥   䠩
*/
static int AddExist(WIN32_FIND_DATA *fd , FCSBPARM *parm )
{
  bool isExist = false, FileChange = false;    
  int  i, j;

  if( parm->ExistUnsortList )
  {
     char FilePath[MAX_PATH];
     strcpy( FilePath, parm->curdirec );
     strcat( FilePath, fd->cFileName );

     for( i = parm->LastUnsortItemMum, j = 0; i < parm->UnsortItemNum && j < MaxDeepRepeatScan; i++ )
     {
        if( !strcmp( FilePath, parm->fptru[i].Path) ){

           if( isExist == false ) isExist = true;

           if( FileChange == false )
           { 
              if( CompareFileTime( &parm->fptru[i].ftLastWriteTime, &fd->ftLastWriteTime ) == 0 )
                 AddFunc( &parm->fptru[i], parm ); 
              else
                 FileChange = true;
           }         
        }else if( isExist == true ){ //ࠫ  
           break;
        }else
           j++; //ॡࠥ 䠩,    㦭      
     }
  } 

  if( isExist == true && FileChange == false ){ 
     parm->LastUnsortItemMum = i; 
     return true;
  } 
  else if( FileChange == true ){ 
     parm->LastUnsortItemMum = i; 
     return false;
  }else 
     return false;
}


/*
                return values: OK or ERROR
*/
static int get_names_one_file(WIN32_FIND_DATA *fd , FCSBPARM *parm )
{
        int line_len, c, /* got_fn_defn=FALSE, */ definition_line_num = 0;
        char line[LINE_LEN] /* , *name_ptr */, fn_name[64]="", savefnname[64]="";
        FILE *fp_source = NULL;
        FUNC ff;
        char *source_file_name; // = strlen( fd->cAlternateFileName ) ? fd->cAlternateFileName : fd->cFileName;
        char *Mes[2], buf[100];
        int addflag, addnum = 0;
        int numl;

        parm->filecount ++;

        if ( !parm->Editor ) {
           source_file_name = strlen( fd->cAlternateFileName ) ? fd->cAlternateFileName : fd->cFileName;
           if( (fp_source = fopen(source_file_name, "rb")) == NULL )
                return 1;
        }

        parm->line_num=1;

        if ( !( parm->filecount % 10 ) && !parm->Editor ) {
           Mes[0] = GetMsg( MesProcScan );
           Mes[1] = buf;
           sprintf( buf, GetMsg( MesProcDone ), parm->filecount );
           _Info.Message( _Info.ModuleNumber, 0, NULL, Mes, 2, 0 );
        }

        if( parm->TypeProject == 1 ) // ஥ 
           while( TRUE )
           {
                   addflag = 0;
                   do {
                      line_len = 0;
                      while( (c = filter_data(fp_source,parm)) != EOF && c != ';' && c != PARENS && line_len < LINE_LEN-1 && c != BRACES && c != DEFINE )
                              line[line_len++] = (char)c;

                      if( c == BRACES ){ //塞    ᫥                              
                         line[ line_len ] = 0;
                         if( Get_Struct_Name( fp_source, line, fn_name, parm ) != NULL )
                         {
                            addflag = 1;           
                            definition_line_num = parm->line_num;
                         }
                         break;      
                      }
                      if( c == DEFINE ) //뤥塞    #define 
                      {
                         if( Get_Define_Name( parm, fn_name ) != NULL )
                         {
                            addflag = 1;           
                            definition_line_num = parm->line_num-1;/**/
                         }  
                         break;      
                      }

                      if( c == EOF )
                              break;
                      if( c == ';' )                  /* bypass externals representing data items */
                           continue;                       /* now we know line ended with PARENS           */

                      line[ line_len ] = 0;   /* terminate line */

                   /*
                           At this point, line either contains a function definition
                           or a function type declaration or something else, perhaps
                           an occurrence of parentheses in a data item definition.  We
                           only want function definitions.
                   */

                                                   /* extract the function name from this possible         */
                                                   /* function definition, and save it in fn_name.         */              
                      strcpy( savefnname, fn_name );
                      strcpy( fn_name, get_fn_name( line , parm ) );
                      numl = definition_line_num;
                      definition_line_num = parm->line_num;

                                                   /* exclude the case of parenthetical expressions        */
                                                   /* in a data definition, e.g. within array brackets */
                      if( !fn_name[0] ) {
                              strcpy( fn_name, savefnname );
                              definition_line_num = numl;
                              // operator? Exclude all prev. definitions
                              if ( strstr( line, OPERATOR ) ) addflag = 0;
                              continue;
                              }
   //                   else addflag = 1;

                                                  /* skip white space */
                      while( (c = filter_data(fp_source,parm)) != EOF && isspace(c) )
                              ; /* EMPTY */

   // if line ends with single ':', it's a c++ definition of class init., so bypass 
   // all after it whilenext symbol will be BRACES

                      if ( c == ':' ) {
                         while( c != BRACES && c != EOF )
                            c = filter_data(fp_source,parm);

                      }

                      if( c == ';' || c == ',' )      /* functions type check declaration,    */
                              {
                              strcpy( fn_name, savefnname );
                              definition_line_num = numl;
                              continue;                               /*      so bypass it                        */
                              }
                      if( c == PARENS ) {             /* something pointing to a function                     */
                              strcpy( fn_name, savefnname );
                              definition_line_num = numl;
                              continue;               /* bypass it (could be a mistake - if           */
                              }                       /* it's a function returning a pointer          */
                                                      /* to a function we'll miss it)                 */
                      if( c == EOF )
                              break;
                      addflag = 1;
                      if ( c != BRACES ) ffungetc( c, fp_source, parm );

                   } while ( c != BRACES ) ;

                                                                   /* skip any parameter declarations -         */
                                                                   /*      eat until braces or EOF                  */
   //                while( c != BRACES && c != EOF )
   //                        c = filter_data(fp_source,parm);

                     if ( ( parm->Editor || strlen( parm->curdirec ) + strlen( fd->cFileName ) < 64 ) && addflag && *fn_name   ) {

                        strncpy( ff.Func , fn_name , 63 );
                        ff.Func[63] = 0;

                        if ( !parm->Editor ) {
                          strcpy( ff.Path, parm->curdirec );
                          strcat( ff.Path, fd->cFileName );
                          ff.ftLastWriteTime = fd->ftLastWriteTime;
                        } else *ff.Path = 0;
                        ff.Line = (WORD)definition_line_num;
                        addnum ++;
                        if ( AddFunc( &ff , parm ) ) return -1;
                     }

                     if ( c == EOF ) break;
           }
        else if( parm->TypeProject == 2 ) //rsl -஥
        {
            char *str = (char *)malloc( 1024 );
            char *fn, *curstr;
            for(;;)
            {
              if( fgets( str, 1024, fp_source ) != NULL )
              {
                 definition_line_num++;
                 if( (curstr = strstr( str, "macro" )) !=NULL || (curstr = strstr( str, "Macro" )) != NULL || (curstr = strstr( str, "MACRO" )) != NULL ) 
                 {
                     curstr += 5;
                     while( *curstr != 0 && *curstr == ' ' ) curstr++;   
                     if( *curstr )
                     {
                        fn = curstr;
                        //ᬥ頥    ய楤
                        while( *curstr != 0 && *curstr != ' ' && *curstr != '\t' && *curstr != '\r' && *curstr != '\n' && *curstr != '(' ) curstr++;                                          
                        *curstr = 0;

                        strncpy( ff.Func, fn, 63 );
                        ff.Func[63] = 0;
                        if ( !parm->Editor ) {
                          strcpy( ff.Path, parm->curdirec );
                          strcat( ff.Path, fd->cFileName );
                          ff.ftLastWriteTime = fd->ftLastWriteTime;
                        } else *ff.Path = 0;
                        ff.Line = (WORD)definition_line_num;
                        addnum ++;
                        if ( AddFunc( &ff , parm ) ) return -1;
                     }
                     
                 } 
              }else
                 break;
            } 
            if( str )
               free( str );
        }  

        if( !parm->Editor && addnum == 0 )
        {
           memset( &ff, 0, sizeof(FUNC) );
           strcpy( ff.Path, parm->curdirec );
           strcat( ff.Path, fd->cFileName );
           ff.ftLastWriteTime = fd->ftLastWriteTime;
           if ( AddFunc( &ff , parm ) ) return -1;            
        } 
         
        if ( fp_source ) fclose(fp_source);   
        return OK;
}






static int FunTest( WIN32_FIND_DATA *fd , FCSBPARM *parm )
{
  if ( parm->Editor ) {
     return ( get_names_one_file( NULL , parm ) );
  } else {
/*
     int l;
     char *ptr = fd->cFileName + ( l = strlen( fd->cFileName ) );
     while ( *ptr != '.' && l > 0 ) { ptr--; l--; }
     if ( l<=0 ) return 0;
     if ( !stricmp( ptr+1, "c" ) || !stricmp( ptr+1, "cpp" ) || !stricmp( ptr+1, "h" ) || !stricmp( ptr+1, "hpp" ))
*/
     int stat; 
     stat = BelongToUs( fd->cFileName, parm->FileMask );
     if ( stat != 0 ){
        parm->TypeProject = stat;
        if( AddExist( fd, parm ) == false ) //஢塞, ᫨ 䠩  , ࠧ 塞
           //䠩 , ᪠㥬           
           return ( get_names_one_file( fd , parm ) );
     } 
  }
  return 0; 
}




static int ScanCurDir( LPCTSTR mask , FCSBPARM *parm )
{
 int stat = 0;
 WIN32_FIND_DATA fd;
 HANDLE hf; // = FindFirstFile( mask, &fd );
 char buf[MAX_PATH];

 if ( parm->Editor ) {
    FunTest( NULL , parm );
    return 0;
 }

 hf = FindFirstFile( mask, &fd );
 if ( hf != INVALID_HANDLE_VALUE ) {
  while ( !stat ) {
    if ( parm->Recurse && ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) && ( strcmp( fd.cFileName, "." ) ) && ( strcmp( fd.cFileName, ".." ) ) ) {
       strcpy( buf, parm->curdirec );
       strcat( parm->curdirec, fd.cFileName );
       strcat( parm->curdirec, "\\" );
       SetCurrentDirectory( fd.cFileName );
       stat = ScanCurDir( mask , parm );
       SetCurrentDirectory( ".." );
       strcpy( parm->curdirec, buf );
    }
    else {
       FunTest( &fd , parm );
       stat = 0;
    }
    if ( !stat ) {
       if ( !FindNextFile( hf, &fd ) ) stat = 2;
    }
  }
  FindClose( hf );
 } // else stat = 1;

 if ( stat == 2 ) stat = 0;

 return stat;
}



static int GetList( FCSBPARM *parm, bool OpenUnSortFile = false )
{
 FILE *fp = NULL; //  = fopen( parm->FILEOUT, "r" );
 FUNC f;
 HANDLE hs;
 char str[300];
 char *Mes[2], buf[100];
 long ll = 0;
 char *NameFile = OpenUnSortFile ? FARPRJU : parm->FILEOUT;

 Mes[0] = GetMsg( MesProcFileRd );
 Mes[1] = buf;

 if ( !parm->Editor ) fp = fopen( NameFile, "r" );

 if ( fp ) {
    hs = _Info.SaveScreen(0,0,-1,-1);
    while ( !feof( fp ) ) {
       if ( fgets( str, 299, fp ) ){
          char * i = str, *j;

          ll++;
          if ( !( ll % 100 ) ) {
             sprintf( buf, GetMsg( MesProcFileRd2 ), ll );
             _Info.Message( _Info.ModuleNumber, 0, NULL, Mes, 2, 0 );
          }
          

          while ( *i && *i != '?' ) i++;

          if ( *i ) {
             *i = 0;
             strcpy( f.Func, str );
             //।塞 
             j = ++i;
             while ( *i && *i != '?' ) i++;
             if ( *i ) {
                *i = 0;
                strcpy( f.Path, j );
                //।塞  ப
                j = ++i;
                while ( *i && *i != '?' ) i++;
                if ( *i ) {
                   *i = 0;
                   f.Line = (WORD)atoi( j );
                   //।塞 ६ 䨪樨 䠩  
                   j = ++i;
                   f.ftLastWriteTime.dwLowDateTime = (DWORD)strtoul( j, &i, 10 );  
                   j = ++i;                  
                   f.ftLastWriteTime.dwHighDateTime = (DWORD)strtoul( j, &i, 10 );  
                   /*  
                   while ( *i && *i != '?' ) i++;
                   if ( *i ) {                                   
                      *i = 0;
                      f.ftLastWriteTime.dwLowDateTime = (DWORD)atoi( j );
                      *i = 0;
                      f.ftLastWriteTime.dwHighDateTime = (DWORD)atoi( i+1 );
                      AddFunc( &f, parm, OpenUnSortFile );
                   }
                   */
                   AddFunc( &f, parm, OpenUnSortFile );
                }
             }
          }
       }
    }
    _Info.RestoreScreen(hs);
    fclose(fp);
 } else {
    if( OpenUnSortFile == false )
    {  
       parm->filecount = 0;
       hs = _Info.SaveScreen(0,0,-1,-1);
       if ( !ScanCurDir( "*.*" , parm ) )  {
          _Info.RestoreScreen(hs);
          Sort( parm );
       }
       else {
          _Info.RestoreScreen(hs);
          return 1;
       }
    }else
       return 1;
 }  
 return 0;
}


static int * MakeBreakKeys( FCSBPARM *parm )
{
 int * i = (int*)calloc( 100, sizeof(int) );
 int j,k=0;
 if ( i ) {
    for ( j='A'; j<='Z' ; j++ )
       i[k++] = j;
    for ( j='0'; j<='9' ; j++ )
       i[k++] = j;
    i[k++] = parm->vk_underline;
    i[k++] = parm->vk_semicol;
    i[k++] = parm->vk_not;
    i[k++] = parm->vk_less;
    i[k++] = parm->vk_grt;
    i[k++] = 8;
    i[k++] = ' ';
    i[k] = 0;
 }
 return i;
}



static void InvokeFilter( char * Filter, int * menun, int * first , FCSBPARM *parm )
{
 int i;
 int flag = 0;

 *menun = 0;
 *first = 0;

 if ( !strlen( Filter ) ) { *menun = parm->itemnum; return; }

 for ( i=0 ; i< parm->itemnum; i++ ) {

    if ( !strnicmp( parm->fptr[i].Func , Filter, strlen(Filter) ) ) // Ok.
       { if ( !flag ) *first = i; flag = 1; (*menun)++; }
    else                                                     // not passed
       if ( flag ) { break; }
 }

}



static int InitParm( FCSBPARM *parm )
{
 parm->ptrsize = DPTRSIZE;
 parm->UnsortPtrSize = DPTRSIZE;
 strcpy( parm->FILEOUT, FARPRJ );

 parm->vk_underline = VkKeyScan( '_' ) & 255;
 parm->vk_semicol   = VkKeyScan( ':' ) & 255;
 parm->vk_not       = VkKeyScan( '~' ) & 255;
 parm->vk_less      = VkKeyScan( '<' ) & 255;
 parm->vk_grt       = VkKeyScan( '>' ) & 255;

 if( !parm->fptr )
 {
    parm->fptr = (FUNC*)calloc( parm->ptrsize , sizeof( FUNC ) );
    if ( !parm->fptr ) { SayError( MesErrMemory ); return -1; }
 }

 if( !parm->fptru )
 {  
   parm->fptru = (FUNC*)calloc( parm->UnsortPtrSize , sizeof( FUNC ) );
   if ( !parm->fptru ) { SayError( MesErrMemory ); return -1; }
 }

 parm->CountStatic = GetRegKey(HKEY_CURRENT_USER,"",( parm->Editor ? CTSTATICE : CTSTATIC ), ( parm->Editor ? 1 : 0 ) );
 parm->CountInline = GetRegKey(HKEY_CURRENT_USER,"",( parm->Editor ? CTINLINEE : CTINLINE ), 1 );
 parm->CountCPP    = GetRegKey(HKEY_CURRENT_USER,"",( parm->Editor ? CTCPPE    : CTCPP    ), 1 );
 parm->ExitMenu    = GetRegKey(HKEY_CURRENT_USER,"",QUITMENU, 0 );
 parm->Recurse     = GetRegKey(HKEY_CURRENT_USER,"",RECURSE  , 1 );
 parm->MoveToFun   = GetRegKey(HKEY_CURRENT_USER,"",MOVETOFUN , 1 );

 GetRegKey( HKEY_CURRENT_USER, "", FILEMASK , parm->FileMask, DEFAULTFILEMASK, 512 );

 return 0;
}


static void CloseParm( FCSBPARM *parm )
{
 if ( parm->fptr  ) { free( parm->fptr  ) ; parm->fptr = NULL; }
 if ( parm->fptru ) { free( parm->fptru ) ; parm->fptru = NULL; }
}



#pragma argsused
HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{
 // int choice;
 HANDLE hs;
 FCSBPARM parm;

 try {

    memset( &parm, 0, sizeof( FCSBPARM ) );

    if ( _Info.StructSize < sizeof(struct PluginStartupInfo) ) {
       SayError( MesVersion );
       return(INVALID_HANDLE_VALUE);
    }

    if ( OpenFrom == OPEN_EDITOR ) {
       parm.Editor = 1;
    }

    if ( !InitParm( &parm ) ) {

       switch ( Item ) {

          case 0:

             if ( !GetList( &parm ) ) {
                 if ( parm.itemnum > 0 ) {

                   int BreakCode = 0;
                   int * BreakKeys = MakeBreakKeys(&parm);
                   char Filter[80] = "";
                   int i;

                   parm.mptr = (FARMENU*)calloc( parm.itemnum , sizeof( FARMENU ) );
                   if ( parm.mptr && BreakKeys ) {
                      char zbuf[26];
                      for ( i=0 ; i<parm.itemnum; i++) {
                         parm.mptr[i].Selected = parm.mptr[i].Checked = parm.mptr[i].Separator = 0;
                         if ( strlen( parm.fptr[i].Path ) <= 25 )
                            strcpy( zbuf, parm.fptr[i].Path );
                         else {
                            strncpy( zbuf, parm.fptr[i].Path + strlen (parm.fptr[i].Path) - 25 , 25 );
                            zbuf[0] = zbuf[1] = '.';
                         }
                         if ( !parm.Editor )
                            sprintf( parm.mptr[i].Text , "%-39.39s  %25.25s", parm.fptr[i].Func, zbuf );
                         else {
                            strncpy( parm.mptr[i].Text, parm.fptr[i].Func, 127 );
                            parm.mptr[i].Text[127] = 0;
                         }
                      }
                      int selnum = -1;

                      while ( BreakCode != -1 ) {

                         int menun = 0, first = 0;
                         int choice;
                         char head[100];


                         InvokeFilter( Filter, &menun, &first , &parm );
                         sprintf( head , GetMsg( MesMenuHead ), Filter );

                         choice = _Info.Menu( _Info.ModuleNumber,-1, -1, 0, FMENU_SHOWAMPERSAND|FMENU_WRAPMODE,
                                              head, GetMsg( MesMenuStatus ), CONTENTS, BreakKeys,
                                              &BreakCode, &parm.mptr[first], menun );

                         if ( selnum >= 0 ) parm.mptr[selnum].Selected = 0;
                         parm.mptr[(selnum = first+choice)].Selected = 1;

                         if ( BreakCode != -1 ) {
                             int cod = BreakKeys[BreakCode];
                             if ( cod == parm.vk_underline ) cod = '_';
                             if ( cod == parm.vk_semicol )   cod = ':';
                             if ( cod == parm.vk_not )       cod = '~';
                             if ( cod == parm.vk_less )      cod = '<';
                             if ( cod == parm.vk_grt )       cod = '>';

                             switch ( cod ) {
                                case 8:
                                   if ( strlen( Filter ) ) {
                                      Filter[ strlen(Filter) - 1 ] = 0;
                                   }
                                   break;
                                default:
                                   if ( strlen( Filter ) < MAXFILTER ) {
                                      Filter[strlen(Filter) ] = (char) cod;
                                      Filter[strlen(Filter)+1 ] = 0;
                                   }
                                   break;
                             }
                         } else if ( choice > -1 )  {
                            if ( OpenFrom == OPEN_EDITOR ) {
                               struct EditorSetPosition Pos;
                               Pos.CurLine = parm.fptr[choice+first].Line-1;
                               Pos.CurPos = 0;
                               Pos.CurTabPos = -1;
                               Pos.TopScreenLine = -1;
                               Pos.LeftPos = 0;
                               Pos.Overtype = -1;
                               _Info.EditorControl(ECTL_SETPOSITION, &Pos );
                               BreakCode = -1;
                            } else {

                               _Info.Editor( parm.fptr[choice+first].Path, NULL, 0, 0, -1, -1, 0, ( parm.MoveToFun? parm.fptr[choice+first].Line : 0 ), 0 );
                               if ( parm.ExitMenu ) BreakCode = -1;
                               else BreakCode = 0;
                            }
                         }

                      }

                   } else SayError( MesErrMemory );

                   if ( parm.mptr )      { free( parm.mptr ); parm.mptr = NULL; }
                   if ( BreakKeys ) { free( BreakKeys ); }

                 } else SayError( MesNoFiles );
             }
             break;
          case 1:
             if ( OpenFrom != OPEN_EDITOR ) {
                // save to file

                //砥 ᯨ᮪ 㭪権 ஢  䠩,    
                //  ᪠஢ ࠧࠥ ⮫쪮  䠩  
                if( GetList( &parm, true ) == 0 )
                   parm.ExistUnsortList = 1;

                parm.filecount = 0;
                hs = _Info.SaveScreen(0,0,-1,-1);
                if ( !ScanCurDir( "*.*" , &parm ) ){
                   int i;
                   FILE *fp  = fopen( parm.FILEOUT, "w" );
                   FILE *fpu = fopen( FARPRJU, "w" );

                   //塞 ஢ 䠩
                   for ( i=0 ; i<parm.itemnum; i++ )
                      fprintf( fpu , "%s?%s?%d?%u?%u\n", parm.fptr[i].Func, parm.fptr[i].Path, parm.fptr[i].Line, parm.fptr[i].ftLastWriteTime.dwLowDateTime, parm.fptr[i].ftLastWriteTime.dwHighDateTime );

                   //㥬  塞 ஢ 䠩
                   Sort( &parm );
                   for ( i=0 ; i<parm.itemnum; i++ )
                      fprintf( fp , "%s?%s?%d?%u?%u\n", parm.fptr[i].Func, parm.fptr[i].Path, parm.fptr[i].Line, parm.fptr[i].ftLastWriteTime.dwLowDateTime, parm.fptr[i].ftLastWriteTime.dwHighDateTime );

                   fclose(fp);
                   fclose(fpu);
                }
                _Info.RestoreScreen(hs);
             }
             break;
       }

    } // else SayError( MesErrMemory );

    CloseParm( &parm );                                        
 }

 __except(1) {
  MessageBeep( 0xFFFFFFFF );
  MessageBox( NULL, "An unhandled exception occured. Program terminated.", "FCSB - Fatal error", MB_OK | MB_ICONSTOP );
 } 

  return(INVALID_HANDLE_VALUE);
}




void WINAPI _export GetPluginInfo(struct PluginInfo *Info)
{
  Info->StructSize=sizeof(struct PluginInfo);
  Info->Flags = PF_EDITOR;
  Info->DiskMenuStringsNumber = 0;
  static char *PluginMenuStrings[2];
  static char *PluginConfStrings[1];

  PluginMenuStrings[0]=GetMsg(MesMenuRun);
  PluginMenuStrings[1]=GetMsg(MesMenuScan);
  PluginConfStrings[0]=GetMsg(MesConfig);
  Info->PluginMenuStrings=PluginMenuStrings;
  Info->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);

  Info->PluginConfigStrings = PluginConfStrings;
  Info->PluginConfigStringsNumber=sizeof(PluginConfStrings)/sizeof(PluginConfStrings[0]);
}

//
// plugin export funcs
//
void WINAPI _export SetStartupInfo(struct PluginStartupInfo *info)
{
  _Info=*info;
  strcpy(PluginRootKey,info->RootKey);
  strcat(PluginRootKey,"\\FCSB");
}

int WINAPI _export Configure(int ItemNumber)
{
  switch(ItemNumber)
  {
    case 0:
      return(Config());
  }
  return(FALSE);
}
